searchNodes=[{"doc":"Ejects an Ejectable App to a standalone code repository. Examples $ mix uniform.eject Trillo $ mix uniform.eject Tweeter --confirm $ mix uniform.eject Hatmail --confirm --destination ../../new/dir Command line options --destination – output directory for the ejected code. Read the Configuration section of the Getting Started guide to understand how the destination is chosen if this option is omitted. --confirm – affirm &quot;yes&quot; to the prompt asking you whether you want to eject. Ejection Step By Step When you eject an app by running mix uniform.eject MyApp , the following happens: The destination directory is created if it doesn't exist. All files and directories in the destination are deleted, except for .git , _build , and deps . All files in lib/my_app and test/my_app are copied to the destination. All files specified in the base_files section of the Blueprint are copied to the destination. All Lib Dependencies of the app are copied to the destination. This includes all of lib/dep_name and test/dep_name automatically. For each file copied, a set of transformations are applied to the file contents – except for files specified with cp and cp_r . mix format is ran on the ejected codebase. In step 2, .git is kept to preserve the Git repository and history. deps is kept to avoid having to download all dependencies after ejection. _build is kept to avoid having to recompile the entire project after ejection. In step 7, running mix format tidies up things like chains of newlines that may appear from applying Code Fences . It also prevents you from having to think about code formatting in modify .","ref":"Mix.Tasks.Uniform.Eject.html","title":"Mix.Tasks.Uniform.Eject","type":"task"},{"doc":"Generates an uniform.exs file so that the given app can be ejected with mix uniform.eject . Usage $ mix uniform.gen.app some_app_name Created lib/some_app_name/uniform.exs Running that command will create lib/some_app_name/uniform.exs . This will enable mix uniform.eject SomeAppName to work without failing.","ref":"Mix.Tasks.Uniform.Gen.App.html","title":"Mix.Tasks.Uniform.Gen.App","type":"task"},{"doc":"Initializes a Base Project repository with the bare minimum setup required for using Uniform . Adds a Blueprint module Adds required configuration to config/config.exs The remainder of installation steps are listed in the Getting Started guide. Usage $ mix uniform.init Created lib/base_app/uniform/blueprint.ex Added configuration in config/config.exs","ref":"Mix.Tasks.Uniform.Init.html","title":"Mix.Tasks.Uniform.Init","type":"task"},{"doc":"The Uniform System is an architecture for maintaining multiple Elixir apps from a single Elixir project in a way that minimizes duplicate work and maximizes sharing capabilities. It's like a monolith. But unlike a monolith, the apps can be &quot;ejected&quot; into separate codebases that only contain the code needed by each app. Recommended Guides In order to understand and use this library, we heavily recommend reading the following guides: The Uniform System: How It Works Dependencies Code Transformations The Setting up a Phoenix project guide is recommended if you're building Phoenix apps. Usage mix uniform.eject Tweeter Read about the Uniform System for details about how it works. Installation Consult the Getting Started guide to add Uniform to an Elixir application. In summary, you'll need to: Add the dep in mix.exs : {:uniform, &quot;~&gt; 0.1.0&quot;} Add a Blueprint module to your project Configure your Elixir app to point to the Blueprint module Add uniform.exs manifests to each Ejectable Application Add to the Blueprint module all the files necessary to eject a working application","ref":"Uniform.html","title":"Uniform","type":"module"},{"doc":"An App struct, representing an application to be ejected. See the type definition for more details. App Struct Availability This struct is available in the Blueprint module in these locations: Uniform.Blueprint.extra/1 callback Uniform.Blueprint.target_path/2 callback Uniform.Blueprint.base_files/1 macro Uniform.Blueprint.modify/2 macros In these callbacks and macros, you can make decisions about what to eject or how files should be modified using the app . Checking App Dependencies The depends_on?/3 utility can be used to determine whether a app depends on a mix or lib dependency. depends_on? ( app , :mix , :norm ) See depends_on?/3 for more information.","ref":"Uniform.App.html","title":"Uniform.App","type":"module"},{"doc":"Indicates if an app requires a given dependency. Pass in the app , the dependency type (either :lib or :mix ), and the name of the dependency (like :tesla or :my_lib_directory ) and the function will return true if the dependency will be ejected along with the app. Examples depends_on? ( app , :mix , :some_included_mix_dep ) depends_on? ( app , :mix , :not_included_dep ) depends_on? ( app , :lib , :some_included_lib ) Examples in Context base_files do if depends_on? ( app , :mix , :some_hex_dependency ) do file &quot;file_needed_by_some_hex_dependency&quot; end end modify ~r/^test/ . + _ ( test ) . exs / , fn file , app -&gt; if depends_on? ( app , :lib , :my_data_lib ) do file else String . replace ( file , &quot;use Oban.Testing, repo: MyDataLib.Repo&quot; , &quot;use Oban.Testing, repo: OtherDataLib.Repo&quot; ) end end","ref":"Uniform.App.html#depends_on?/3","title":"Uniform.App.depends_on?/3","type":"function"},{"doc":"An App struct, representing a discrete, self-contained application to be ejected. Example Note that the extra key contains everything you put in extra in uniform.exs for the given app. It also contains anything returned by Uniform.Blueprint.extra/1 . # Uniform.App &lt; destination : &quot;/Users/me/code/tweeter&quot; , extra : [ company : :fake_co , logo_file : &quot;pixel&quot; , some_data : &quot;from uniform.exs&quot; ] , name : %{ camel : &quot;Tweeter&quot; , hyphen : &quot;tweeter&quot; , module : Tweeter , underscore : &quot;tweeter&quot; } , ... &gt;","ref":"Uniform.App.html#t:t/0","title":"Uniform.App.t/0","type":"type"},{"doc":"Defines the ejection blueprint for your project. When used, the blueprint expects the :templates option. For example, the blueprint: defmodule Blueprint do use Uniform.Blueprint , templates : &quot;priv/uniform-templates&quot; end Would search for templates in the priv/uniform-templates directory. See template/2 for more information. The base_files Section The base_files section specifies files that should be ejected which aren't in lib/my_app . (When running mix uniform.eject MyApp .) defmodule Blueprint do use Uniform.Blueprint , templates : &quot;...&quot; base_files do file &quot;my_main_app/application.ex&quot; cp_r &quot;assets&quot; # ... end end See base_files/1 for more information. Files that are always ejected There are a handful of files that are automatically ejected. You do not need to specify these in the base_files section. mix.exs mix.lock .gitignore .formatter.exs test/test_helper.exs The deps Section Besides the base_files section, the blueprint can also contain a deps section to configure dependencies. defmodule Blueprint do use Uniform.Blueprint , templates : &quot;...&quot; deps do always do mix :phoenix lib :my_component_library end mix :absinthe do mix_deps [ :absinthe_plug , :dataloader ] end end end See deps/1 for more information. Modifying files programmatically with modify Lastly, modify can be used whenever you want to transform file contents during ejection. You can specify a specific filepath or use a regex to match multiple files. defmodule Blueprint do use Uniform.Blueprint , templates : &quot;...&quot; modify &quot;assets/js/app.js&quot; , fn file , app -&gt; String . replace ( file , &quot;SOME_VALUE_PER_APP&quot; , app . extra [ :some_value ] ) end modify ~r/_worker.ex/ , &amp; MyApp.Modify . modify_workers / 1 See modify/2 for more information. Preserving files Whenever running mix uniform.eject , the contents in the destination directory will be deleted except for the .git , deps , and _build directories. If there are any other files or directories in the project's root folder that you would like to preserve (by not deleting them), specify them with @preserve . # .env will not be deleted immediately before ejection @preserve [ &quot;.env&quot; ] Full Example Below is an example Blueprint module that shows off a majority of the features that can be used. defmodule MyApp.Uniform.Blueprint do use Uniform.Blueprint , templates : &quot;lib/uniform/templates&quot; # do not delete this root file when clearing the destination @preserve [ &quot;.env&quot; ] @impl Uniform.Blueprint def extra ( app ) do theme = case app . name . underscore do &quot;empire_&quot; &lt;&gt; _ -&gt; :empire &quot;rebel_&quot; &lt;&gt; _ -&gt; :rebel end # set `app.extra[:theme]` [ theme : theme ] end @impl Uniform.Blueprint def target_path ( path , app ) do if is_web_file? ( path ) do # modify the path to put it in `lib/some_app_web` String . replace ( path , &quot;lib/ \#{ app . name . underscore } /&quot; , &quot;lib/ \#{ app . name . underscore } _web/&quot; ) else path end end # files to eject in every app, which are outside `lib/that_app` base_files do # copy these directories wholesale; do NOT run them through code modifiers cp_r &quot;assets&quot; # eject these files which aren&#39;t in lib/the_app_directory file &quot;.credo.exs&quot; file &quot;.github/workflows/elixir.yml&quot; file &quot;priv/static/ \#{ app . extra [ :theme ] } -favicon.ico&quot; file &quot;lib/my_app_web.ex&quot; # eject a file from an EEx template at &quot;lib/uniform/templates/config/runtime.exs.eex&quot; # configure the templates directory on line 2 template &quot;config/runtime.exs&quot; # conditionally eject some files if deploys_to_aws? ( app ) do file &quot;file/required/by/aws&quot; template &quot;dynamic/file/required/by/aws&quot; end if depends_on? ( app , :lib , :some_lib ) do template &quot;dynamic/file/required/by/some_lib&quot; end end # run the file contents through this modifier if the file is ejected modify &quot;lib/my_app_web/templates/layout/root.html.heex&quot; , file , app do file |&gt; String . replace ( &quot;empire-favicon.ico&quot; , &quot; \#{ app . extra [ :theme ] } -favicon.ico&quot; ) |&gt; String . replace ( &quot;empire-apple-touch-icon.png&quot; , &quot; \#{ app . extra [ :theme ] } -apple-touch-icon.png&quot; ) end # configure dependencies from mix.exs and `lib/` deps do # always eject the dependencies in the `always` section; # don&#39;t require adding them to uniform.exs always do lib :my_app do # only eject the following files in `lib/my_app` only [ &quot;lib/my_app/application.ex&quot; ] end lib :my_app_web do # only eject the following files in `lib/my_app_web` only [ &quot;lib/my_app_web/endpoint.ex&quot; , &quot;lib/my_app_web/router.ex&quot; , &quot;lib/my_app_web/channels/user_socket.ex&quot; , &quot;lib/my_app_web/views/error_view.ex&quot; , &quot;lib/my_app_web/templates/layout/root.html.heex&quot; , &quot;lib/my_app_web/templates/layout/app.html.heex&quot; , &quot;lib/my_app_web/templates/layout/live.html.heex&quot; ] end # always include these mix dependencies mix :credo mix :ex_doc mix :phoenix mix :phoenix_html end # if absinthe is included, also include absinthe_plug and dataloader mix :absinthe do mix_deps [ :absinthe_plug , :dataloader ] end lib :my_data_lib do # if my_data_lib is included, also include other_lib, faker, and norm lib_deps [ :other_lib ] mix_deps [ :faker , :norm ] # if my_data_lib is included, also eject these files file Path . wildcard ( &quot;priv/my_data_repo/**/*.exs&quot; , match_dot : true ) file Path . wildcard ( &quot;test/support/fixtures/my_data_lib/**/*.ex&quot; ) end end end","ref":"Uniform.Blueprint.html","title":"Uniform.Blueprint","type":"behaviour"},{"doc":"Inside of a deps do block, any Mix or Lib dependencies that should be included in every ejected app should be wrapped in an always do block: deps do always do # always eject the contents of `lib/some_lib` lib :some_lib # always eject the some_mix Mix dependency mix :some_mix end end","ref":"Uniform.Blueprint.html#always/1","title":"Uniform.Blueprint.always/1","type":"macro"},{"doc":"This callback works like the except/1 instruction for Lib Dependencies, except that it applies to the lib folder of the ejected app itself. When running mix uniform.eject MyApp , any files in lib/my_app or test/my_app which match the paths or regexes returned by app_lib_except will not be ejected. def app_lib_except ( app ) do [ &quot;lib/ \#{ app . name . underscore } /hidden_file.ex&quot; ] end","ref":"Uniform.Blueprint.html#c:app_lib_except/1","title":"Uniform.Blueprint.app_lib_except/1","type":"callback"},{"doc":"The base_files section is where you specify files outside of an ejected app's lib/my_app and test/my_app directories which should always be ejected. This section has access to an app variable which can be used to build the instructions or conditionally include certain files with if . base_files do # interpolating the app name into a path dynamically cp &quot;priv/static/images/ \#{ app . name . underscore } _logo.png&quot; # conditional instructions if deploys_to_fly_io? ( app ) do template &quot;fly.toml&quot; end end Note that if conditionals cannot be nested here. API Reference The following instructions can be given in the base_files section: file/2 ejects a single file or list of files template/2 creates a new file on ejection from an EEx template cp/1 copies a file (like file/2 ) without running it through Code Transformations . This is useful for binary files such as images or executable. cp_r/1 copies an entire directory of files without Code Transformations . Example base_files do file &quot;.credo.exs&quot; file Path . wildcard ( &quot;config/**/*.exs&quot; ) template &quot;config/runtime.exs&quot; cp &quot;bin/some-executable&quot; cp_r &quot;assets&quot; except [ &quot;lib/ \#{ app . name . underscore } /hidden_file.ex&quot; ] end Files in lib Typically, the base_files section only contains files that aren't in lib , since files in lib/app_being_ejected and lib/required_lib_dependency are ejected automatically. # ❌ Don&#39;t do this base_files do file &quot;lib/my_lib/some_file.ex&quot; end # ✅ Instead, do this (lib/my_app/uniform.exs) [ lib_deps : [ :my_lib ] ] Files outside lib but tied to Lib Dependencies If a file or template should only be ejected in the case that a certain Lib Dependency is included, we recommend placing that in lib/2 inside the deps/1 section instead of in base_files . # ❌ Don&#39;t do this base_files do if depends_on? ( app , :lib , :my_lib ) do file &quot;some_file&quot; end end # ✅ Instead, do this deps do lib :my_lib do file &quot;some_file&quot; end end","ref":"Uniform.Blueprint.html#base_files/1","title":"Uniform.Blueprint.base_files/1","type":"macro"},{"doc":"cp works exactly like file/2 , except that no transformations are applied to the file . The file is copied as-is with File.cp!/3 . Options cp takes a chmod option, which sets the mode for the file after it's copied. See the possible permission options . Examples base_files do # every ejected app will have bin/some-binary, with the ACL mode changed to 555 cp &quot;bin/some-binary&quot; , chmod : 0o555 end deps do lib :pdf do # apps that include the pdf lib will also have bin/convert cp &quot;bin/convert&quot; end end","ref":"Uniform.Blueprint.html#cp/2","title":"Uniform.Blueprint.cp/2","type":"function"},{"doc":"cp_r works like cp/2 , but for directory instead of a file. The directory is copied as-is with File.cp_r!/3 . None of the files are ran through Code Modifiers. This is useful for directories that do not require modification, and contain many files. For example, the assets/node_modules directory in a Phoenix application would take ages to copy with file Path.wildcard(&quot;assets/node_modules/**/*&quot;) . Instead, use cp_r &quot;assets/node_modules&quot; . Examples base_files do cp_r &quot;assets&quot; end deps do lib :some_lib do cp_r &quot;priv/files_for_some_lib&quot; end end","ref":"Uniform.Blueprint.html#cp_r/2","title":"Uniform.Blueprint.cp_r/2","type":"function"},{"doc":"Uniform automatically catalogs all Mix deps by looking into mix.exs to discover all Mix deps. It also catalogs all Lib deps by scanning the lib/ directory. If you need to configure anything about a Mix or Lib dep, such as other dependencies that must be bundled along with it, use the deps block. See mix/2 , lib/2 , and always/1 for more details. Example deps do always do lib :my_app do only [ &quot;lib/my_app/application.ex&quot; ] end mix :phoenix end mix :absinthe do mix_deps [ :absinthe_plug , :dataloader ] end lib :my_custom_aws_lib do lib_deps [ :my_utilities_lib ] mix_deps [ :ex_aws , :ex_aws_ec2 ] end end","ref":"Uniform.Blueprint.html#deps/1","title":"Uniform.Blueprint.deps/1","type":"macro"},{"doc":"In the deps section of your Blueprint, you can specify that a Lib Dependency excludes certain files. This works much like the except option that can be given when importing functions with import/2 . In the example below, for any app that depends on :aws , every file in lib/aws and test/aws will be ejected except for lib/aws/hidden_file.ex . deps do lib :aws do except [ &quot;lib/aws/hidden_file.ex&quot; ] end end","ref":"Uniform.Blueprint.html#except/1","title":"Uniform.Blueprint.except/1","type":"function"},{"doc":"A hook to add more data to app.extra , beyond what's in the Uniform Manifest file . Example You may want to set the theme based on the name of the ejectable app. In this case, add an 'extra' entry called 'theme', which will then be available through the app struct: def extra ( app ) do theme = case app . name . underscore do &quot;work_&quot; &lt;&gt; _ -&gt; :work &quot;personal_&quot; &lt;&gt; _ -&gt; :personal _ -&gt; raise &quot;App name must start with Work or Personal to derive theme.&quot; end [ theme : theme ] end","ref":"Uniform.Blueprint.html#c:extra/1","title":"Uniform.Blueprint.extra/1","type":"callback"},{"doc":"In base_files and lib blocks, file is used to specify files that are not in a lib/ directory which should be ejected in the app or along with the lib. Use Path.wildcard/1 for shorter code Note that file can take a path or a list of paths. You can use Path.wildcard as in the example below to target multiple files instead of listing them on separate lines. Options file takes a chmod option, which sets the mode for the given file after it's ejected. See the possible permission options . Examples base_files do # every ejected app will include these file &quot;assets/js/app.js&quot; file Path . wildcard ( &quot;config/**/*.exs&quot; ) file &quot;some/file&quot; , chmod : 0o777 end deps do lib :aws do # for every app that includes the aws lib dependency, # some_aws_fixture.xml will also be included file &quot;test/support/fixtures/some_aws_fixture.xml&quot; end end","ref":"Uniform.Blueprint.html#file/2","title":"Uniform.Blueprint.file/2","type":"function"},{"doc":"Uniform considers all directories in the project root's lib/ directory to be &quot;lib dependencies&quot;. Since Uniform is aware of all lib dependencies in lib/ , you don't need to tell it about them. However, there are a few scenarios where you do need to list them in your Blueprint module: Specifying which lib dependencies should always be ejected. (See Uniform.Blueprint.always/1 .) To specify that a lib dependency has other mix or lib dependencies. (I.e. Other mix packages or lib directories should always be ejected along with it.) To specify to eject other files that aren't in a lib/ directory alongside a lib dependency. Including Lib Dependencies in an App To eject a lib dependency with a specific app (but not all), make sure to put it in the app's Uniform Manifest file , or make it a lib_dependency of another dependency in the Manifest. Examples deps do always do # every app will have lib/utilities lib :utilities # every app will have lib/mix, but only my_app.some_task.ex will be ejected lib :mix do only [ &quot;lib/mix/tasks/my_app.some_task.ex&quot; ] end end # If uniform.exs says to include sso_auth, then `lib/sso_auth` will be copied # along with `lib/other_utilities`. However, `some_file.ex` will never be # included. Also, the tesla mix dep will be included. lib :sso_auth do mix_deps [ :tesla ] lib_deps [ :other_utilities ] except [ &quot;lib/sso_auth/some_file.ex&quot; ] end mix :oban do # any app that is ejected with oban will also have oban_pro and oban_web mix_deps [ :oban_pro , :oban_web ] end end Associated Files Sometimes, when a Lib Dependency is ejected with an app, there are other files outside of lib/that_library which should also be ejected. In this scenario, you can use these instructions used in base_files/1 to denote them. file/2 template/2 cp/1 cp_r/1 lib :my_data_source do file Path . wildcard ( &quot;priv/my_data_source_repo/**&quot; , match_dot : true ) file Path . wildcard ( &quot;test/support/fixtures/my_data_source/**/*.ex&quot; ) template &quot;some/template/for/my_data_source&quot; end","ref":"Uniform.Blueprint.html#lib/2","title":"Uniform.Blueprint.lib/2","type":"macro"},{"doc":"Since Uniform is aware of all mix dependencies in mix.exs , you don't need to tell it about them. However, there are two scenarios where you do need to list out mix dependencies: Specifying which mix dependencies should always be ejected. (See Uniform.Blueprint.always/1 .) Whenever a mix dependency has other mix dependencies. (I.e. Other mix packages should always be ejected with it.) Including Mix Dependencies in an App To eject a mix dependency with a specific app (but not all), make sure to include it as a dependency of lib dependencies (see lib/2 ) or put it in the app's Uniform Manifest file . Examples deps do always do # every app will have credo and ex_doc mix :credo mix :ex_doc end mix :oban do # any app that is ejected with oban will also have oban_pro and oban_web mix_deps [ :oban_pro , :oban_web ] end end","ref":"Uniform.Blueprint.html#mix/2","title":"Uniform.Blueprint.mix/2","type":"macro"},{"doc":"Specify a file path or regex pattern and a transformation function, which must return the new file contents as a string. The first argument of modify must be either the relative path of a file in your Base Project, or a regex which matches against those relative paths. # exact (relative) path modify &quot;tests/path/to/specific_test.exs&quot; , fn file -&gt; ... end # regex modify ~r/.+_test.exs/ , fn file -&gt; ... end The second argument of modify must either be a function capture modify ~r/.+_test.exs/ , &amp; MyApp.Modify . modify_tests / 1 modify ~r/.+_test.exs/ , &amp; MyApp.Modify . modify_tests / 2 Or an anonymous function modify ~r/.+_test.exs/ , fn file -&gt; # ... end modify ~r/.+_test.exs/ , fn file , app -&gt; # ... end If the function is 1-arity, it will receive the file contents. If it's 2-arity, it will receive the file contents and the Uniform.App struct. Examples modify &quot;config/config.exs&quot; , file do file &lt;&gt; ~S&#39;&#39;&#39; if config_env() in [:dev, :test] do import_config &quot;\#{config_env()}.exs&quot; end &#39;&#39;&#39; end modify ~r/.+_worker.ex/ , fn file , app -&gt; String . replace ( file , &quot;SOME_VALUE_PER_APP&quot; , app . extra [ :some_value ] ) end","ref":"Uniform.Blueprint.html#modify/2","title":"Uniform.Blueprint.modify/2","type":"macro"},{"doc":"In the deps section of your Blueprint, you can specify that a Lib Dependency only includes certain files. These work much like the only option that can be given when importing functions with import/2 . In the example below, for any app that depends on :gcp , only lib/gcp/necessary_file.ex will be ejected. Nothing else from lib/gcp or test/gcp will be ejected. deps do lib :gcp do # NOTHING in lib/gcp or test/gcp will be included except these: only [ &quot;lib/gcp/necessary_file.ex&quot; ] end end","ref":"Uniform.Blueprint.html#only/1","title":"Uniform.Blueprint.only/1","type":"function"},{"doc":"Use this callback to modify the path of ejected files. It will be called for every file in a lib directory, along with every file specified via file , template , cp , and cp_r . If you don't want to modify the path , just return it. If not defined, the default implementation is: def target_path ( path , _app ) , do : path Example You may want to place certain files in lib/ejected_app_web instead of lib/ejected_app . Let's say you have an is_web_file? function that identifies whether the file belongs in the _web directory. target_path might be something like this: def target_path ( path , app ) do if is_web_file? ( path ) do # modify the path to put it in `lib/some_app_web` String . replace ( path , &quot;lib/ \#{ app . name . underscore } /&quot; , &quot;lib/ \#{ app . name . underscore } _web/&quot; ) else path end end","ref":"Uniform.Blueprint.html#c:target_path/2","title":"Uniform.Blueprint.target_path/2","type":"callback"},{"doc":"In base_files and lib blocks, template is used to specify EEx templates that should be rendered and then ejected. Template Directory and Destination Path Uniform templates use a &quot;convention over configuration&quot; model that works like this: At the top of your Blueprint module, you specify a template directory like this: use Uniform, templates: &quot;lib/uniform/templates&quot; Templates must be placed in this directory at the relative path that they should be placed in, in the ejected directory. Templates must have the destination filename, appended with .eex . Companion guide Consult Building files from EEx templates for a more detailed look at constructing and effectively using templates for ejection. Options template takes a chmod option, which sets the mode for the rendered file after it's ejected. See the possible permission options . Examples use Uniform , templates : &quot;priv/uniform-templates&quot; base_files do # priv/uniform-templates/config/runtime.exs.eex will be rendered, and the # result will be placed in `config/runtime.exs` in every ejected app template &quot;config/runtime.exs&quot; end deps do lib :datadog do # for every app that includes `lib/datadog`, # priv/uniform-templates/datadog/prerun.sh.eex will be rendered, and # the result will be placed in `datadog/prerun.sh` template &quot;datadog/prerun.sh&quot; , chmod : 0o555 end end","ref":"Uniform.Blueprint.html#template/2","title":"Uniform.Blueprint.template/2","type":"function"},{"doc":"Utilities for building code transformations with modify in your Uniform.Blueprint module.","ref":"Uniform.Modifiers.html","title":"Uniform.Modifiers","type":"module"},{"doc":"Build code transformations to apply Code Fences with this function. Note that code fences are already applied automatically to .ex/.exs files as well as .js/.jsx/.ts/.tsx files. Examples # code fences for SQL files modify ~r/.sql$/ , fn file , app -&gt; Uniform.Modifiers . code_fences ( file , app , &quot;--&quot; ) end # code fences for Rust files modify ~r/.rs$/ , fn file , app -&gt; Uniform.Modifiers . code_fences ( file , app , &quot;//&quot; ) end","ref":"Uniform.Modifiers.html#code_fences/3","title":"Uniform.Modifiers.code_fences/3","type":"function"},{"doc":"","ref":"getting-started.html","title":"Getting Started","type":"extras"},{"doc":"Add :uniform as a dependency in mix.exs and wrap your entire dependency list in # uniform:deps and # /uniform:deps comments, like this. defp deps do # uniform:deps [ { :uniform , &quot;~&gt; 0.1.0&quot; } , ... ] # /uniform:deps end","ref":"getting-started.html#add-uniform-to-mix-exs","title":"Getting Started - Add Uniform to mix.exs","type":"extras"},{"doc":"After adding :uniform to mix.exs and running mix deps.get , run mix uniform.init This will Create a Blueprint module and add Configuration , which you can do manually if you'd rather by following the steps below. Create a Blueprint module Next, create a Blueprint module. It will contain all of the details for how mix uniform.eject should behave whenever you tell it to eject a specific application. defmodule MyApp.Uniform.Blueprint do use Uniform.Blueprint , templates : &quot;lib/my_app/uniform/templates&quot; end You can name the module whatever you like, but we suggest putting it in lib/my_app/uniform/blueprint.ex and specifying the templates directory alongside it in lib/my_app/uniform/templates . Configuration In config/config.exs put the following line. (Changing the blueprint value to match the name of your Blueprint module name above.) config :my_app , Uniform , blueprint : MyApp.Uniform.Blueprint You can also optionally set a default destination for ejected apps. # With optional :destination config :my_app , Uniform , blueprint : MyApp.Uniform.Blueprint , destination : &quot;/Users/me/ejected&quot; If destination is ommitted, the default is one level up from the Base Project's root folder. The --destination option of mix uniform.eject takes precedence and overrides both of these behaviors.","ref":"getting-started.html#run-mix-uniform-init","title":"Getting Started - Run mix uniform.init","type":"extras"},{"doc":"Designate all lib directories that represent an Ejectable App by placing an uniform.exs manifest file into each directory. You can do so with mix uniform.gen.app , which creates an empty manifest containing code comments to help you start. mix uniform.gen.app my_application_name Or, if you want to do this manually, you can start with a barebones manifest that contains an empty list. # lib/my_application_name/uniform.exs [ ] Once you start structuring your project for the Uniform System, you'll add Lib and Mix Dependencies in this file. [ lib_deps : [ :my_data_source , :utilities ] , mix_deps : [ :csv , :chromic_pdf ] ] More on uniform.exs See uniform.exs Options for an explanation of supported options.","ref":"getting-started.html#add-uniform-manifests","title":"Getting Started - Add Uniform Manifests","type":"extras"},{"doc":"At this point, you should be able to run mix uniform.eject MyApplicationName And be able to successfully create an ejected codebase. However, it will probably lack critical code that is needed to run properly. This leads us to the final step of Building a Blueprint .","ref":"getting-started.html#ejecting-an-application","title":"Getting Started - Ejecting an Application","type":"extras"},{"doc":"Read the documentation for Uniform.Blueprint for the full range of features to build out your Blueprint module. Since each Elixir application is different, it is up to you to determine which files need to be ejected to make mix uniform.eject emit a working application. Using Phoenix? We recommend developers building Phoenix projects read about the Uniform System , then consult the how-to guide for Setting up a Phoenix Project . An example barebones Blueprint might look like this. defmodule MyApp.Uniform.Blueprint do use Uniform.Blueprint base_files do file &quot;lib/my_app/application.ex&quot; file &quot;lib/my_app_web/endpoint.ex&quot; cp_r &quot;assets&quot; template &quot;config/runtime.exs&quot; end deps do always do mix :phoenix mix :phoenix_html lib :utilities end lib :my_data_graph do mix_deps [ :absinthe ] end end end","ref":"getting-started.html#build-the-blueprint","title":"Getting Started - Build the Blueprint","type":"extras"},{"doc":"With the Uniform System, multiple apps are maintained together in a single Elixir codebase. When you're ready to deploy an app, it's &quot;ejected&quot; out into separate codebases that only contains the code needed by the app.","ref":"how-it-works.html","title":"The Uniform System: How It Works","type":"extras"},{"doc":"A Base Project is the single Elixir application that houses all of the applications. When you run the Base Project in your development environment, you are running your entire portfolio of applications simultaneously. Since Uniform projects are just an Elixir application, the lib directory is central. It contains directories for: Ejectable Apps Lib Dependencies (shared libraries) It also contrains a Blueprint module configuring which files are copied to ejected repositories. A Base Project directory structure might look like this. + my_base_app + lib + my_first_app + my_second_app + utilities + ui_components","ref":"how-it-works.html#what-is-a-base-project","title":"The Uniform System: How It Works - What is a Base Project?","type":"extras"},{"doc":"For the purposes of this documentation, ejecting an app means Copying the code used by the application to a separate, standalone code repository, without including code that the application doesn't need. Ejecting is done like this: mix uniform.eject MyAppName See mix uniform.eject for more details. This task essentially makes code repositories &quot;out of thin air&quot; by taking only the relevent code from your Base Project. We use Continuous Integration (CI) and Continuous Deployment (CD) tools to automate the process of committing code to ejected repos and deploying to live environments. A single merged code change can result in dozens of apps being safely deployed without any human involvement.","ref":"how-it-works.html#what-is-ejecting","title":"The Uniform System: How It Works - What is &quot;Ejecting&quot;?","type":"extras"},{"doc":"An Ejectable App is simply an application that can be ejected from the Base Project. Each Ejectable App is stored in a sub-directory of lib . To identify a directory inside lib as an Ejectable App, create an uniform.exs file inside the directory. uniform.exs Options uniform.exs files must contain a keyword list, in this structure: # lib/my_app/uniform.exs [ mix_deps : [ :gql , :timex ] , lib_deps : [ :some_lib_directory ] , extra : [ some_data : &quot;just for this app&quot; ] ] mix_deps - Mix Dependencies of the app; each must exist in mix.exs . lib_deps - Lib Dependencies of the app; each must exist as a directory in lib/ . extra - additional user-defined data to configure the app. The purpose of the :extra key mix uniform.eject does not by change its behavior based on the data in extra , but it is placed in app.extra so that you can use it to make decisions in templates or in the base_files or modify sections in your Blueprint module. For 'global' values available to all ejectable apps, use the Uniform.Blueprint.extra/1 callback implementation. No Keys in uniform.exs are required Note that uniform.exs does not need to include mix_deps , lib_deps , or extra . They all default to an empty list. By implication, [] is a valid uniform.exs file.","ref":"how-it-works.html#what-is-an-ejectable-app","title":"The Uniform System: How It Works - What is an Ejectable App?","type":"extras"},{"doc":"Whenever you run mix uniform.eject MyApp , there are 4 simple rules that the library uses to decide which files to include or exclude from the ejected codebase. All files specified by the base_files section of the Blueprint are included. These are files to include with every app. All files in lib/my_app and test/my_app are included. For every Lib Dependency , all files in lib/dep_name and test/dep_name are included. A small handful of files common to most Elixir projects are always included. There are some caveats to these rules. The files in rule 2 are subject to the lib_app_except callback. The files in rule 3 are subject to only and except instructions.","ref":"how-it-works.html#how-files-are-included-excluded-by-mix-uniform-eject","title":"The Uniform System: How It Works - How files are included/excluded by mix uniform.eject","type":"extras"},{"doc":"","ref":"dependencies.html","title":"Dependencies","type":"extras"},{"doc":"A Lib Dependency is a directory in the Base Project 's lib/ directory that contains a code library used by Ejectable Apps . Lib Dependencies are used to share non-public code between Ejectable Apps with less ceremony than other mechanisms like private Hex packages. A Lib Dependency is referenced by an atom that matches the name of the directory in lib/ . For example, a library in lib/utilities would be referenced in uniform.exs or in the Blueprint module as :utilities .","ref":"dependencies.html#lib-dependencies","title":"Dependencies - Lib Dependencies","type":"extras"},{"doc":"Uniform is aware of the deps in your mix.exs . Whenever an app is ejected, it removes all mix dependencies that aren't explicitly needed by the app. This is accomplished by wrapping your list of dependencies in the following comments: defp deps do # uniform:deps [ ... ] # /uniform:deps end","ref":"dependencies.html#mix-dependencies","title":"Dependencies - Mix Dependencies","type":"extras"},{"doc":"There are three methods to specify which Lib and Mix dependencies are required by an App: Include the dependency for a single Ejectable App by saying so in uniform.exs . # lib/my_app/uniform.exs [ lib_deps : [ :utilities ] , mix_deps : [ :absinthe ] ] Include the depencency in all Ejectable Apps by placing the dependency in the always section of your Blueprint module. deps do always do lib :utilities mix :absinthe end end Make it a &quot;sub-dependency&quot; of a dependency from method 1 or 2 by using the lib_deps or mix_deps macros in your deps section . (See &quot;Chained Dependencies&quot; below.) deps do lib :some_included_lib do lib_deps [ :utilities ] end mix :some_included_mix do mix_deps [ :absinthe ] end end Chained Dependencies mix uniform.eject will follow chains of sub-dependencies completely. If these are true: The app's uniform.exs manifest includes lib_deps: [:foo] The deps section of your Blueprint says that foo has lib_deps: [:bar] The deps section of your Blueprint says that bar has lib_deps: [:baz] Then the ejected codebase will include lib/foo , lib/bar , and lib/baz .","ref":"dependencies.html#adding-dependencies-to-an-app","title":"Dependencies - Adding Dependencies to an App","type":"extras"},{"doc":"During mix uniform.eject , there are 4 code transformations applied to file contents. These transformations happen to every file, except those ejected with cp and cp_r . They occur in this order . Unused mix.exs Dependencies are Removed Blueprint Modifiers are ran The Base Project Name is replaced with the ejected app's name Code Fences are processed Disabling Code Transformations for a file If you have a file that should not have Code Transformations applied upon ejection, use cp instead of file . If there is an entire directory of contents that should not be modified, use cp_r , which will be much faster.","ref":"code-transformations.html","title":"Code Transformations","type":"extras"},{"doc":"Any Mix Dependency that is not directly or indirectly required by the app via mix.exs or the Blueprint module is removed from the ejected mix.exs .","ref":"code-transformations.html#mix-exs-dependency-removal","title":"Code Transformations - mix.exs Dependency Removal","type":"extras"},{"doc":"Users can specify arbitrary modifications that should be applied to various files using the modify macro in the Blueprint module: modify ~r/.+_worker.ex/ , fn file , app -&gt; # This code will be ran for every file whose relative path in the base # project matches the regex. # # `file` is a string containing the full file contents. # # `app` is the `Uniform.App` struct of the given app being ejected. # # This is essentially a function body, must return a string with # the modified file contents to eject. end modify &quot;lib/my_app_web/router.ex&quot; , fn file -&gt; # This modifier is like the one above, but the transformation will only # be ran for `lib/my_app_web/router.ex`. end","ref":"code-transformations.html#modifiers-from-the-ejection-blueprint","title":"Code Transformations - Modifiers from the Ejection Blueprint","type":"extras"},{"doc":"The base project name, appearing anywhere in a file, is replaced by the ejected app name. This applies to the following formats: base_app , base-app , and BaseApp . The base project name is the :app key returned by project in the mix.exs file of the Base Project. (For example, :my_base_app below.) # mix.exs def project do [ app : :my_base_app , # &lt;- base project name ... ] end Given the above mix.exs , if you were to run mix uniform.eject MyEjectableApp : my_base_app would be replaced with my_ejectable_app my-base-app would be replaced with my-ejectable-app MyBaseApp would be replaced with MyEjectableApp Replacement in file paths This same replacement of base_project_name to ejected_app_name also occurs in file paths, but only with this_format . (Not this-format or ThisFormat .) This means a file at lib/base_project_name/foo.ex would be ejected to lib/ejected_app_name/foo.ex . This means that a file like this defmodule MyBaseAppWeb.Endpoint do use Phoenix.Endpoint , otp_app : :my_base_app socket &quot;/socket&quot; , MyBaseAppWeb.UserSocket , websocket : true , longpoll : false plug MyBaseAppWeb.Router end Would be transformed to this defmodule MyEjectableAppWeb.Endpoint do use Phoenix.Endpoint , otp_app : :my_ejectable_app socket &quot;/socket&quot; , MyEjectableAppWeb.UserSocket , websocket : true , longpoll : false plug MyEjectableAppWeb.Router end","ref":"code-transformations.html#replacing-the-base-project-name","title":"Code Transformations - Replacing the Base Project Name","type":"extras"},{"doc":"In any .ex or .exs file, you can use &quot;code fence&quot; comments to remove code unless certain criteria are met. To remove code unless the ejected app depends on a Lib Dependency called my_lib , wrap it in these comments: # uniform:lib:my_lib # ... code # /uniform:lib:my_lib To remove code unless the ejected app depends on a Mix Dependency called absinthe , wrap it in these comments: # uniform:mix:absinthe # ... code # /uniform:mix:absinthe To remove code unless the ejected app is called MyApp , wrap it in these comments: # uniform:app:my_app # ... code # /uniform:app:my_app Finally, to always remove a chunk of code whenever ejection happens, wrap it in these comments: # uniform:remove # ... code # /uniform:remove Code Fence comments are removed on ejection Note that regardless of whether mix uniform.eject keeps or deletes the code in a code fence, the code fence comments themselves (like # uniform:app:my_app ) are always removed. Furthermore, mix uniform.eject runs mix format on the ejected codebase at the end. So you always end up with &quot;clean&quot; looking code. Code Fences for other languages Code Fences are also processed for .js / .ts / .jsx / .tsx files using JS single-line comments. // uniform:lib:my_lib // ... // /uniform:lib:my_lib If you would like to support Code Fences for other languages or file types, you can do so using Uniform.Blueprint.modify/2 and Uniform.Modifiers.code_fences/3 . # code fences for SQL files modify ~r/ \\. sql$/ , fn file , app -&gt; Uniform.Modifiers . code_fences ( file , app , &quot;--&quot; ) end # code fences for Rust files modify ~r/ \\. rs$/ , fn file , app -&gt; Uniform.Modifiers . code_fences ( file , app , &quot;//&quot; ) end","ref":"code-transformations.html#code-fences","title":"Code Transformations - Code Fences","type":"extras"},{"doc":"This guide walks through a typical process for setting up a Phoenix project. It assumes that you're familiar with The Uniform System and have gone through the Getting Started guide. Imagine creating an entire new application simply by adding a Route and a single LiveView to an existing Elixir project. This is in fact the vision that drove the creation of Uniform. The overhead of experimenting with new apps becomes extremely low, incentivizing the team to try out ideas without being inhibited by initial setup time.","ref":"setting-up-a-phoenix-project.html","title":"Setting up a Phoenix project","type":"extras"},{"doc":"Below is an example Blueprint module for ejecting the files common to Phoenix applications. defmodule MyBaseApp.Uniform.Blueprint do use Uniform.Blueprint , templates : &quot;lib/my_base_app/uniform/templates&quot; base_files do cp_r &quot;assets&quot; cp_r &quot;priv/static&quot; file &quot;lib/my_base_app_web.ex&quot; file Path . wildcard ( &quot;config/**/*.exs&quot; ) file Path . wildcard ( &quot;test/support/*_case.ex&quot; ) end deps do # Always eject the `my_base_app` and `my_base_app_web` libraries. # # Their paths and file contents will replace my_base_app with the ejected # app name automatically. always do lib :my_base_app do only [ &quot;lib/my_base_app/application.ex&quot; , &quot;lib/my_base_app/repo.ex&quot; ] # `match_dot: true` so that we eject `priv/repo/.formatter.exs` file Path . wildcard ( &quot;priv/repo/**/*.exs&quot; , match_dot : true ) end lib :my_base_app_web do only [ &quot;lib/my_base_app_web/endpoint.ex&quot; , &quot;lib/my_base_app_web/gettext.ex&quot; , &quot;lib/my_base_app_web/router.ex&quot; , &quot;lib/my_base_app_web/telemetry.ex&quot; , &quot;lib/my_base_app_web/channels/user_socket.ex&quot; , &quot;lib/my_base_app_web/templates/layout/app.html.heex&quot; , &quot;lib/my_base_app_web/templates/layout/live.html.heex&quot; &quot;lib/my_base_app_web/templates/layout/root.html.heex&quot; , &quot;lib/my_base_app_web/views/error_helpers.ex&quot; , &quot;lib/my_base_app_web/views/error_view.ex&quot; , &quot;lib/my_base_app_web/views/layout_view.ex&quot; ] end end end end Let's walk through it step by step.","ref":"setting-up-a-phoenix-project.html#setting-up-your-blueprint-module","title":"Setting up a Phoenix project - Setting up your Blueprint module","type":"extras"},{"doc":"base_files do cp_r &quot;assets&quot; cp_r &quot;priv/static&quot; file &quot;lib/my_base_app_web.ex&quot; file Path . wildcard ( &quot;config/**/*.exs&quot; ) file Path . wildcard ( &quot;test/support/*_case.ex&quot; ) end In the base_files section, we specify files that should always be ejected in every app. Phoenix apps will typically have CSS and JS assets in the assets directory. They'll also have static files to be served as-is in priv/static . Some of these files are binary (non-text) files, and we assume none of them need to pass through the Code Transformation phase. That's why the first two lines are included. cp_r &quot;assets&quot; cp_r &quot;priv/static&quot; Note that cp_r instructs mix uniform.eject to copy all the directory contents (using File.cp_r!/3 ). Phoenix apps typically have an Web module which is used to construct Controllers, Views, Routers, and LiveViews. Since this file is typically in lib/ directly (and not in a sub-directory of lib/ ), we include it here in the base_files section. file &quot;lib/my_base_app_web.ex&quot; We also proceed with the assumption that the ejected app will need the Base Project's configuration files. file Path . wildcard ( &quot;config/**/*.exs&quot; )","ref":"setting-up-a-phoenix-project.html#the-base_files-section","title":"Setting up a Phoenix project - The base_files section","type":"extras"},{"doc":"In the deps section, we put both lib :my_base_app and lib :my_base_app_web inside always do so that their contents are always ejected without having to specify lib_deps: [:my_base_app, :my_base_app_web] in the uniform.exs manifest of every app. deps do always do lib :my_base_app do # ... end lib :my_base_app_web do # ... end end end For :my_base_app , we use an only instruction to exclude all files in lib/my_base_app and test/my_base_app except for application.ex and repo.ex . lib :my_base_app do only [ &quot;lib/my_base_app/application.ex&quot; , &quot;lib/my_base_app/repo.ex&quot; ] file Path . wildcard ( &quot;priv/repo/**/*.exs&quot; , match_dot : true ) end You may have a setup that requires you to add more files, such as mailer.ex . Note that we also include all of the Repo's migrations and seeds scripts with file Path.wildcard(...) . The match_dot: true ensures priv/repo/.formatter.exs is ejected so that the ejected codebase is formatted properly. For :my_base_app_web , we also use an only instruction to only include relevant files. lib :my_base_app_web do only [ &quot;lib/my_base_app_web/endpoint.ex&quot; , &quot;lib/my_base_app_web/gettext.ex&quot; , &quot;lib/my_base_app_web/router.ex&quot; , &quot;lib/my_base_app_web/telemetry.ex&quot; , &quot;lib/my_base_app_web/channels/user_socket.ex&quot; , &quot;lib/my_base_app_web/templates/layout/app.html.heex&quot; , &quot;lib/my_base_app_web/templates/layout/live.html.heex&quot; &quot;lib/my_base_app_web/templates/layout/root.html.heex&quot; , &quot;lib/my_base_app_web/views/error_helpers.ex&quot; , &quot;lib/my_base_app_web/views/error_view.ex&quot; , &quot;lib/my_base_app_web/views/layout_view.ex&quot; ] end","ref":"setting-up-a-phoenix-project.html#the-deps-section","title":"Setting up a Phoenix project - The deps section","type":"extras"},{"doc":"A simple way to set up your Phoenix.Router is to use Code Fences and Uniform.Blueprint.modify/2 . Routes for all of your apps are all placed in the router, with two caveats: Routes are wrapped in Code Fences so that they're removed when other apps are ejected. Paths are prefixed with /app-name so that each app exists at a nice URL for development. The prefixes are removed with modify . defmodule MyBaseAppWeb.Router do use MyBaseAppWeb , :router pipeline :browser do # ... end # uniform:remove # Place &quot;internal pages&quot; that should never be ejected here. # See &quot;Internal Pages&quot; below this code example. scope &quot;/&quot; , SomeAppWeb do pipe_through :browser get &quot;/internal-team-page&quot; , InternalTeamController , :index end # /uniform:remove # uniform:app:some_app scope &quot;/some-app&quot; , SomeAppWeb do pipe_through :browser get &quot;/widgets&quot; , WidgetController , :index get &quot;/widgets/new&quot; , WidgetController , :new post &quot;/widgets/new&quot; , WidgetController , :create get &quot;/widgets/:widget_id&quot; , WidgetController , :show end # /uniform:app:some_app # uniform:app:another_app scope &quot;/another-app&quot; , SomeAppWeb do pipe_through :browser get &quot;/widgets&quot; , WidgetController , :index get &quot;/widgets/new&quot; , WidgetController , :new post &quot;/widgets/new&quot; , WidgetController , :create get &quot;/widgets/:widget_id&quot; , WidgetController , :show end # /uniform:app:another_app end defmodule MyBaseApp.Uniform.Blueprint do use Uniform.Blueprint , templates : &quot;...&quot; modify &quot;lib/my_base_app_web/router.ex&quot; , fn file , app -&gt; String . replace ( file , &quot;scope \\&quot; / \#{ app . name . hyphen } \\&quot; &quot; , &quot;scope \\&quot; / \\&quot; &quot; ) end end The Code Fences (comments like this: # uniform:app:some_app ) will cause the code to be removed when ejecting a different app. The simple code transformer defined with modify changes scope &quot;/some-app&quot; , SomeAppWeb do To scope &quot;/&quot; , SomeAppWeb do In the ejected codebase. This method is a great starting point. Once you reach dozens of apps, you may want to consider other methods that allow you to branch out to more separation in your Router. Internal Pages Since you're adopting a model that serves all of your applications from a single server in the development environment, it can be useful to add other pages that aren't intended to be ejected with any app. For example, a page that catalogs and links to your various apps. We recommend adding these as often as you like, and wrapping them all in # uniform:remove Code Fences as in the example above.","ref":"setting-up-a-phoenix-project.html#the-phoenix-router","title":"Setting up a Phoenix project - The Phoenix Router","type":"extras"},{"doc":"There are other files crucial for Elixir apps, such as application.ex , mix.exs , and config/*.exs files. Similarly to the Phoenix Router, we recommend adding all of the code needed for every application and Lib Dependency to each of these places and using Code Fences to remove code that isn't needed for any given application. Application Your Application file at lib/my_base_app/application.ex is a critical piece of Elixir applications since it's used to start processes and supervisors at the start of the application. Here's what an example Application file would look like with Code Fences applied. defmodule MyBaseApp.Application do use Application def start ( _type , _args ) do children = [ MyBaseAppWeb.Endpoint , { Phoenix.PubSub , name : MyBaseApp.PubSub } , MyBaseAppWeb.Presence , MyBaseAppWeb.Telemetry , # uniform:lib:my_first_data_lib MyFirstDataLib.Repo , # /uniform:lib:my_first_data_lib # uniform:lib:my_second_data_lib MySecondDataLib.Repo , MySecondDataLib.Vault , # /uniform:lib:my_second_data_lib # uniform:remove SomeDevelopmentOnlyDB.Repo , # /uniform:remove # uniform:mix:oban { Oban , ... } , # /uniform:mix:oban ] # ... end end Notice that code which should always be ejected does not get surrounded by Code Fences. mix.exs Some dependencies require modifying mix.exs . For example, the exq Hex package says to add :exq to application in mix.exs . def application do [ applications : [ :logger , :exq ] , # ... ] end But what if only some of your apps require exq? Wrap the exq-specific code in Code Fences, and it will only be included when exq is required. def application do [ applications : [ :logger , # uniform:mix:exq :exq # /uniform:mix:exq ] , # ... ] end You don't need to use Code Fences in deps Note that removing deps from the deps section of mix.exs is automatic if you follow the Getting Started instructions properly. So this would not be required. # ❌ Do NOT wrap deps in code fences defp deps do [ # uniform:mix:jason { :jason , &quot;~&gt; 1.0&quot; } # /uniform:mix:jason ] end Config Files Many dependencies also require configuration. Apply code fences in your configuration files for the same result. # uniform:mix:guardian config :my_base_app , MyBaseApp.Guardian , issuer : &quot;my_base_app&quot; , secret_key : ... # /uniform:mix:guardian","ref":"setting-up-a-phoenix-project.html#code-fences-everywhere","title":"Setting up a Phoenix project - Code Fences Everywhere!","type":"extras"},{"doc":"This guide assumes that you're familiar with The Uniform System and have gone through the Getting Started guide. If you're using The Uniform System it's likely that you have multiple Repos for multiple databases, but you only want to give access for a given database to some of your apps. In this scenario, we recommend creating separate Lib Dependencies (each in its own lib/some_data_source directory) which each encapsulate all of the code for interacting with a single database. This implies that each Lib Dependency would house all of the Ecto Schemas and Context modules related to its database. Structuring the code this way allows you to easily include or exclude the code for a data source in uniform.exs .","ref":"handling-multiple-databases.html","title":"Handling Multiple Databases","type":"extras"},{"doc":"For example, given apps with these uniform.exs manifests # lib/some_app/uniform.exs [ lib_deps : [ :my_data_source ] ] # lib/another_app/uniform.exs [ lib_deps : [ :my_data_source , :other_data_source ] ] # lib/third_app/uniform.exs [ lib_deps : [ :other_data_source ] ] SomeApp would be ejected with all of the code related to interacting with my_data_source AnotherApp would be ejected with the code for both my_data_source and other_data_source ThirdApp would only be ejected with the code for other_data_source","ref":"handling-multiple-databases.html#an-example","title":"Handling Multiple Databases - An Example","type":"extras"},{"doc":"If you take this approach, make sure to configure your Blueprint module to include any Lib or Mix Dependencies of each data source's library. Also, be sure to include migrations and seeds related to the library. lib :my_data_source do lib_deps [ :some_library ] mix_deps [ :faker , ... ] # `match_dot: true` below to include priv/my_data_source_repo/.formatter.exs file Path . wildcard ( &quot;priv/my_data_source_repo/**&quot; , match_dot : true ) end","ref":"handling-multiple-databases.html#configuring-lib-dependencies","title":"Handling Multiple Databases - Configuring Lib Dependencies","type":"extras"},{"doc":"EEx templates can be used to create files in Ejected Apps that don't exist in the Base Project.","ref":"building-files-from-eex-templates.html","title":"Building files from EEx templates","type":"extras"},{"doc":"Imagine you do not use runtime configuration in your Base Project, but you want a config/runtime.exs in your ejected applications. Furthermore, imagine the contents of runtime.exs need to be wildly different between apps based on the Lib and Mix Dependencies of the app. This is an ideal scenario for using an EEx template. Below are the steps to create runtime.exs with an EEx template.","ref":"building-files-from-eex-templates.html#an-example-scenario","title":"Building files from EEx templates - An Example Scenario","type":"extras"},{"doc":"defmodule MyApp.Uniform.Blueprint do use Uniform.Blueprint , templates : &quot;lib/uniform/templates&quot;","ref":"building-files-from-eex-templates.html#step-1-set-the-template-directory-in-your-blueprint-module","title":"Building files from EEx templates - Step 1: Set the template directory in your Blueprint module","type":"extras"},{"doc":"EEx templates must be added in the destination path, relative to the templates directory . So to emit our file into config/runtime.exs , we must create it in lib/uniform/templates/config/runtime.exs.eex \\___________________/ \\________________/\\__/ | | | templates directory destination .eex suffix The path &quot;prefix&quot;, lib/uniform/templates , must match the templates directory specified with use Uniform.Blueprint above. Don't forget the .eex suffix Note above that the filename is the exact file name you want to emit, appended with .eex .","ref":"building-files-from-eex-templates.html#step-2-add-the-eex-file-in-the-correct-relative-path","title":"Building files from EEx templates - Step 2: Add the EEx file in the correct relative path","type":"extras"},{"doc":"Here is an example of what the runtime.exs.eex template might contain. Note the use of Code Fences at the end of the file. import Config &lt; % = if MyApp.Uniform.Blueprint . deploys_to_fly_io? ( app ) do % &gt; config :my_base_app , some_api_token : System . get_env ( &quot;SOME_API_TOKEN&quot; ) &lt; % end % &gt; config :my_base_app , MyBaseAppWeb.Endpoint , url : [ host : System . get_env ( &quot;HOST&quot; ) , port : String . to_integer ( System . get_env ( &quot;EXTERNAL_PORT&quot; ) ) ] , secret_key_base : System . get_env ( &quot;SECRET_KEY_BASE&quot; ) config :my_base_app , MyBaseApp.Repo , priv : &quot;priv/my_base_app_repo&quot; , url : System . get_env ( &quot;DATABASE_URL&quot; ) # uniform:app:some_app config :my_base_app , some_configuration : &quot;just for some_app&quot; # /uniform:app:some_app The App struct in templates In EEx templates, the Uniform.App struct will be available as app . You can use the contents of app.extra to make decisions about what to render in the template. Also, the Uniform.App.depends_on?/3 utility is available as depends_on? and can be used like this: depends_on?.(app, :mix, :absinthe) Code Transformations and templates Code Transformations are ran after the template is generated. This means that you can inject the base app name into a template anywhere you want the ejected app name to appear, and it will be transformed into the ejected app name. So in the example above, instead of writing config :&lt;%= app.name.underscore %&gt; , we just wrote, config :my_base_app .","ref":"building-files-from-eex-templates.html#step-3-write-the-template","title":"Building files from EEx templates - Step 3: Write the template","type":"extras"},{"doc":"","ref":"use-cases.html","title":"Use Cases","type":"extras"},{"doc":"The Uniform System is powerful in scenarios in which you want to: Maintain a portfolio of applications. Deploy them separately. Keep many aspects of them in sync. Share capabilities between apps. This makes the Uniform System especially powerful for software organizations that do not have an entire team dedicated to each application.","ref":"use-cases.html#from-a-high-level","title":"Use Cases - From a High Level","type":"extras"},{"doc":"In our specific use case, we build and maintain applications across companies for a large enterprise. The companies have their own distinct branding, themes, deployment pipelines, and assurance processes. However, they share data access patterns, UI libraries, authentication mechanisms, and many other common features. By leveraging the Uniform System, we're able to perform many changes to our entire portfolio of applications in the time that it would take to make the change to a single application. For example, when we find a security issue in our shared application architecture, we patch it once and all apps are instantly updated. What could have been a lengthy, involved auditing and patching process across dozens of apps becomes much simpler and less time-intensive. The Uniform System also helps us accomplish sharing capabilities among apps. In the process of building an application, we create a UI component for suggesting results as the user types. Without any extra effort, since our UI library is shared among all applications, this component becomes instantly available in all other apps.","ref":"use-cases.html#enterprises","title":"Use Cases - Enterprises","type":"extras"},{"doc":"Agencies that build custom applications for multiple independent clients often find themselves squeezed for time as they try to balance budget and time constraints. They're often left needing to make hard calls about whether there is enough time and money to add features or capabilities. The Uniform System can help an agency leverage as much value as possible from their portfolio of already-built applications as they start new projects. Instead of rebuilding core pieces like project boilerplate, authentication systems, or integrations with third party services, those capabilities are available from the start. (As long as they're built with sharing in mind.) Furthermore, since the Uniform System emits standalone codebases for each application, an agency is able to leverage this extreme level of reuse while still having separate codebases that belong to each client.","ref":"use-cases.html#agencies","title":"Use Cases - Agencies","type":"extras"},{"doc":"The Uniform System is not for everyone, but it can be very powerful in environments where a team or developer is tasked with developing a large base of applications that have many similarities or could share many capabilities.","ref":"benefits-and-disadvantages.html","title":"Benefits and Disadvantages","type":"extras"},{"doc":"Higher leverage to maintain a portfolio of applications. There is a sense of higher return on investment (ROI) as more and more applications are built. When you add a new capability, refactor deprecations, or change an implementation, the results are automatically incorporated into all of your applications. Reduce dependency drift. Ejected applications derive their Mix and NPM dependencies from the Base Project. This eliminates distractions that come from supporting multiple versions across a portfolio. No more grappling with missing features or incompatible APIs. Faster feedback. When you change anything shared, your changes are automatically made and tested into all applications that could be impacted. Share capabilities with lower overhead. Any capability that is developed for a specific application can be moved into a Lib Dependency. At that point, it's instantly available to all other applications in the portfolio. Defer factoring decisions. In the interest of the DRY (Don't Repeat Yourself) principle, there is a motivation to abstract and modularize the moment we start adding a feature. Many advocate for the WET principle (Write Everything Twice) by contrast, since making abstractions too early can often result in an abstraction that &quot;leaks&quot; or is otherwise ill-suited to the specific use case. Since the Uniform System lowers the amount of overhead for shared internal libraries, there are no distinct packages to create up front which makes it much easier to refactor as the API evolves. Global Refactors with peace of mind. When the entire portfolio of applications is managed together, we're free to refactor any interal API and know that we've addressed all invocations across the enterprise. With Elixir compiler warnings and integration tests, CI builds reveal invocations we fail to update. In many cases, this eliminates the burden of maintaining backwards compatibility, leading to simpler internal libraries. &quot;Release&quot; an ejected app at any time. If at any point you need to release control of an ejected application to another entity such as a different development agency, the ejected codebase is already ready as a standalone project. Self-healing properties. - Since mix uniform.eject starts by deleting the contents of the destination codebase, it's possible to modify an ejected codebase temporarily, and then &quot;bring it back in sync&quot; with your Base Project by running mix uniform.eject again. Ejecting an app with mix uniform.eject is meant to be something that can be done over and over without preparation or ceremony.","ref":"benefits-and-disadvantages.html#benefits","title":"Benefits and Disadvantages - Benefits","type":"extras"},{"doc":"Novelty. When new developers join the team, contributors have to learn a new way of working. No contributing to ejected codebases. Changes made directly to an ejected codebase cannot be automatically integrated back into the Base Project, so contributors must have access to the entire portfolio. Complications from running multiple apps at once. Your development environment is more complicated when you're running an entire suite of apps side-by-side. Teams are required to take a disciplined approach to deal with some of these complications. For example, the paths of routes would typically be prefixed with the app name (e.g. localhost:4000/my-app/users instead of localhost:4000/users ), so that paths in your dev environment don't exactly match production. One implication is that if you write links like this &lt;a href=&quot;/users&quot;&gt; instead of like this &lt;a href=&quot;&lt;%= Routes.users_path(...) %&gt;&quot;&gt; the link will work in development but not production. Compilation time. Full recompiles can take a long time for a large portfolio of application. Elixir 1.13 has helped out tremendously in this regard. On the other hand, you'll often end up with a full recompile when changing something in config/config.exs which only has relevance to a single application. CI burn rate. We run Continuous Integration (CI) checks for every ejected application whenever a commit is made to the Base Project. We suggest you do, too. However, this can burn through an order of magnitude more CI minutes.","ref":"benefits-and-disadvantages.html#disadvantages","title":"Benefits and Disadvantages - Disadvantages","type":"extras"}]